#
# For a description of the syntax of this configuration file,
# see the file kconfig-language.txt in the NuttX tools repository.
#

config DEV_LOWCONSOLE
	bool "Low-level console support"
	default n
	depends on ARCH_LOWPUTC
	depends on DEV_CONSOLE
	---help---
		Use the simple, low-level, write-only serial console driver (minimal support)

config SERIAL_REMOVABLE
	bool

config 16550_UART
	bool "16550 UART Chip support"
	default n

if 16550_UART

config 16550_UART0
	bool "16550 UART0"
	default n

if 16550_UART0

config 16550_UART0_BASE
	hex "16550 UART0 base address"

config 16550_UART0_CLOCK
	int "16550 UART0 clock"

config 16550_UART0_IRQ
	int "16550 UART0 IRQ number"

config 16550_UART0_BAUD
	int "16550 UART0 BAUD"
	default 115200

config 16550_UART0_PARITY
	int "16550 UART0 parity"
	default 0
	range 0 2
	---help---
		16550 UART0 parity.  0=None, 1=Odd, 2=Even.  Default: None

config 16550_UART0_BITS
	int "16550 UART0 number of bits"
	default 8
	---help---
		16550 UART0 number of bits.  Default: 8

config 16550_UART0_2STOP
	int "16550 UART0 two stop bits"
	default 0
	---help---
		0=1 stop bit, 1=Two stop bits.  Default: 1 stop bit

config 16550_UART0_RXBUFSIZE
	int "16550 UART0 Rx buffer size"
	default 256
	---help---
		16550 UART0 Rx buffer size.  Default: 256

config 16550_UART0_TXBUFSIZE
	int "16550 UART0 Tx buffer size"
	default 256
	---help---
		16550 UART0 Tx buffer size.  Default: 256

config 16550_UART0_IFLOWCONTROL
	bool "16550 UART0 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable 16550 UART0 RTS flow control

config 16550_UART0_OFLOWCONTROL
	bool "16550 UART0 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable 16550 UART0 CTS flow control

endif # 16550_UART0

config 16550_UART1
	bool "16550 UART1"
	default n

if 16550_UART1

config 16550_UART1_BASE
	hex "16550 UART1 base address"

config 16550_UART1_CLOCK
	int "16550 UART1 clock"

config 16550_UART1_IRQ
	int "16550 UART1 IRQ number"

config 16550_UART1_BAUD
	int "16550 UART1 BAUD"
	default 115200

config 16550_UART1_PARITY
	int "16550 UART1 parity"
	default 0
	range 0 2
	---help---
		16550 UART1 parity.  0=None, 1=Odd, 2=Even.  Default: None

config 16550_UART1_BITS
	int "16550 UART1 number of bits"
	default 8
	---help---
		16550 UART1 number of bits.  Default: 8

config 16550_UART1_2STOP
	int "16550 UART1 two stop bits"
	default 0
	---help---
		0=1 stop bit, 1=Two stop bits.  Default: 1 stop bit

config 16550_UART1_RXBUFSIZE
	int "16550 UART1 Rx buffer size"
	default 256
	---help---
		16550 UART1 Rx buffer size.  Default: 256

config 16550_UART1_TXBUFSIZE
	int "16550 UART1 Tx buffer size"
	default 256
	---help---
		16550 UART1 Tx buffer size.  Default: 256

config 16550_UART1_IFLOWCONTROL
	bool "16550 UART1 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable 16550 UART1 RTS flow control

config 16550_UART1_OFLOWCONTROL
	bool "16550 UART1 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable 16550 UART1 CTS flow control

endif # 16550_UART1

config 16550_UART2
	bool "16550 UART2"
	default n

if 16550_UART2

config 16550_UART2_BASE
	hex "16550 UART2 base address"

config 16550_UART2_CLOCK
	int "16550 UART2 clock"

config 16550_UART2_IRQ
	int "16550 UART2 IRQ number"

config 16550_UART2_BAUD
	int "16550 UART2 BAUD"
	default 115200

config 16550_UART2_PARITY
	int "16550 UART2 parity"
	default 0
	range 0 2
	---help---
		16550 UART2 parity.  0=None, 1=Odd, 2=Even.  Default: None

config 16550_UART2_BITS
	int "16550 UART2 number of bits"
	default 8
	---help---
		16550 UART2 number of bits.  Default: 8

config 16550_UART2_2STOP
	int "16550 UART2 two stop bits"
	default 0
	---help---
		0=1 stop bit, 1=Two stop bits.  Default: 1 stop bit

config 16550_UART2_RXBUFSIZE
	int "16550 UART2 Rx buffer size"
	default 256
	---help---
		16550 UART2 Rx buffer size.  Default: 256

config 16550_UART2_TXBUFSIZE
	int "16550 UART2 Tx buffer size"
	default 256
	---help---
		16550 UART2 Tx buffer size.  Default: 256

config 16550_UART2_IFLOWCONTROL
	bool "16550 UART2 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable 16550 UART2 RTS flow control

config 16550_UART2_OFLOWCONTROL
	bool "16550 UART2 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable 16550 UART2 CTS flow control

endif # 16550_UART2

config 16550_UART3
	bool "16550 UART3"
	default n

if 16550_UART3

config 16550_UART3_BASE
	hex "16550 UART3 base address"

config 16550_UART3_CLOCK
	int "16550 UART3 clock"

config 16550_UART3_IRQ
	int "16550 UART3 IRQ number"

config 16550_UART3_BAUD
	int "16550 UART3 BAUD"
	default 115200

config 16550_UART3_PARITY
	int "16550 UART3 parity"
	default 0
	range 0 2
	---help---
		16550 UART3 parity.  0=None, 1=Odd, 2=Even.  Default: None

config 16550_UART3_BITS
	int "16550 UART3 number of bits"
	default 8
	---help---
		16550 UART3 number of bits.  Default: 8

config 16550_UART3_2STOP
	int "16550 UART3 two stop bits"
	default 0
	---help---
		0=1 stop bit, 1=Two stop bits.  Default: 1 stop bit

config 16550_UART3_RXBUFSIZE
	int "16550 UART3 Rx buffer size"
	default 256
	---help---
		16550 UART3 Rx buffer size.  Default: 256

config 16550_UART3_TXBUFSIZE
	int "16550 UART3 Tx buffer size"
	default 256
	---help---
		16550 UART3 Tx buffer size.  Default: 256

config 16550_UART3_IFLOWCONTROL
	bool "16550 UART3 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable 16550 UART3 RTS flow control

config 16550_UART3_OFLOWCONTROL
	bool "16550 UART3 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable 16550 UART3 CTS flow control

endif # 16550_UART3

choice
	prompt "16550 Serial Console"
	default 16550_NO_SERIAL_CONSOLE
	depends on DEV_CONSOLE

config 16550_UART0_SERIAL_CONSOLE
	bool "16550 UART0 serial console"
	depends on 16550_UART0

config 16550_UART1_SERIAL_CONSOLE
	bool "16550 UART1 serial console"
	depends on 16550_UART1

config 16550_UART2_SERIAL_CONSOLE
	bool "16550 UART2 serial console"
	depends on 16550_UART2

config 16550_UART3_SERIAL_CONSOLE
	bool "16550 UART3 serial console"
	depends on 16550_UART3

config 16550_NO_SERIAL_CONSOLE
	bool "No 16550 serial console"

endchoice # 16550 Serial Console

config 16550_SUPRESS_CONFIG
	bool "Suppress 16550 configuration"
	default n
	---help---
		This option is useful, for example, if you are using a bootloader
		that configures the 16550_UART.  In that case, you may want to
		just leave the existing console configuration in place.  Default: n

config SERIAL_UART_ARCH_IOCTL
	bool "Platform has own custom IOCTL"
	default n

config 16550_REGINCR
	int "Address increment between 16550 registers"
	default 1
	---help---
		The address increment between 16550 registers.  Options are 1, 2, or 4.
		Default: 1

config 16550_REGWIDTH
	int "Bit width of 16550 registers"
	default 8
	---help---
		The bit width of registers.  Options are 8, 16, or 32. Default: 8

config 16550_ADDRWIDTH
	int "Address width of 16550 registers"
	default 8
	---help---
		The bit width of registers.  Options are 8, 16, or 32. Default: 8

endif

#
# MCU serial peripheral driver?
#

config ARCH_HAVE_UART
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_UART0
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_UART1
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_UART2
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_UART3
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_UART4
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_UART5
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_UART6
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_UART7
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_UART8
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_SCI0
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_SCI1
	bool
	default n
	select MCU_SERIAL

config ARCH_HAVE_USART0
	bool
	default n

config ARCH_HAVE_USART1
	bool
	default n

config ARCH_HAVE_USART2
	bool
	default n

config ARCH_HAVE_USART3
	bool
	default n

config ARCH_HAVE_USART4
	bool
	default n

config ARCH_HAVE_USART5
	bool
	default n

config ARCH_HAVE_USART6
	bool
	default n

config ARCH_HAVE_USART7
	bool
	default n

config ARCH_HAVE_USART8
	bool
	default n

config ARCH_HAVE_OTHER_UART
	bool
	default n
	select MCU_SERIAL

#
# USARTn configuration.  Is the USART configured to behave like a UART?
#

comment "USART Configuration"

config USART0_ISUART
	bool "USART0 is a UART"
	default y
	depends on ARCH_HAVE_USART0
	select MCU_SERIAL

config USART1_ISUART
	bool "USART1 is a UART"
	default y
	depends on ARCH_HAVE_USART1
	select MCU_SERIAL

config USART2_ISUART
	bool "USART2 is a UART"
	default y
	depends on ARCH_HAVE_USART2
	select MCU_SERIAL

config USART3_ISUART
	bool "USART3 is a UART"
	default y
	depends on ARCH_HAVE_USART3
	select MCU_SERIAL

config USART4_ISUART
	bool "USART4 is a UART"
	default y
	depends on ARCH_HAVE_USART4
	select MCU_SERIAL

config USART5_ISUART
	bool "USART5 is a UART"
	default y
	depends on ARCH_HAVE_USART5
	select MCU_SERIAL

config USART6_ISUART
	bool "USART6 is a UART"
	default y
	depends on ARCH_HAVE_USART6
	select MCU_SERIAL

config USART7_ISUART
	bool "USART7 is a UART"
	default y
	depends on ARCH_HAVE_USART7
	select MCU_SERIAL

config USART8_ISUART
	bool "USART8 is a UART"
	default y
	depends on ARCH_HAVE_USART8
	select MCU_SERIAL

config MCU_SERIAL
	bool
	default n

#
# Standard serial driver configuration
#

config STANDARD_SERIAL
	bool "Enable standard \"upper-half\" serial driver"
	default y if MCU_SERIAL
	default n if !MCU_SERIAL
	depends on !DEV_LOWCONSOLE
	---help---
		Enable the standard, upper-half serial driver used by most MCU serial peripherals.

config SERIAL_NPOLLWAITERS
	int "Number of poll threads"
	default 2
	depends on !DISABLE_POLL && STANDARD_SERIAL
	---help---
		Maximum number of threads than can be waiting for POLL events.
		Default: 2

config SERIAL_IFLOWCONTROL
	bool
	default n

config SERIAL_OFLOWCONTROL
	bool
	default n

config SERIAL_IFLOWCONTROL_WATERMARKS
	bool "RX flow control watermarks"
	default n
	depends on SERIAL_IFLOWCONTROL
	---help---
		Call the "lower half" rxflowcontrol method whenever the number of
		characters in the serial RX buffer falls above an upper water mark
		level or below a lower watermark level.  The default behavior is to
		call the rxflowcontrol method only when the RX buffer is empty or
		full.

if SERIAL_IFLOWCONTROL_WATERMARKS

config SERIAL_IFLOWCONTROL_LOWER_WATERMARK
	int "RX lower Watermark (percent)"
	default 10
	range 0 100
	---help---
		Call the rxflowcontrol method then there are this amount (or or less)
		data buffered in the serial drivers RX buffer.  This is expressed
		as a percentage of the total size of the RX buffer which may vary
		from instance-to-instance.

config SERIAL_IFLOWCONTROL_UPPER_WATERMARK
	int "RX upper Watermark (percent)"
	default 90
	range 0 100
	---help---
		Call the rxflowcontrol method then there are this amount (or more)
		data buffered in the serial drivers RX buffer.  This is expressed
		as a percentage of the total size of the RX buffer which may vary
		from instance-to-instance.

endif # SERIAL_IFLOWCONTROL_WATERMARKS

config SERIAL_TIOCSERGSTRUCT
	bool "Support TIOCSERGSTRUCT"
	default n
	depends on DEBUG && (MCU_SERIAL || 16550_UART)
	---help---
		As a debug option, many serial bottom half drivers support the TIOCSERGSTRUCT
		that allows you to get the internal driver data structure.  By default, this
		IOCTL is not supported in order to reduce footprint.  But if (1) the driver
		supports the TIOCSERGSTRUCT ioctl, and (2) this option is selected, then
		support for the TIOCSERGSTRUCT will be enabled.

config ARCH_HAVE_SERIAL_TERMIOS
	bool
	default n

config SERIAL_TERMIOS
	bool "Serial TERMIOS support"
	depends on ARCH_HAVE_SERIAL_TERMIOS
	default n
	---help---
		Serial driver supports termios.h interfaces (tcsetattr, tcflush, etc.).
		If this is not defined, then the terminal settings (baud, parity, etc).
		are not configurable at runtime; serial streams cannot be flushed, etc..

#
# Serial console selection
#

choice
	prompt "Serial console"
	default NO_SERIAL_CONSOLE if !ARCH_HAVE_OTHER_UART
	default OTHER_SERIAL_CONSOLE if ARCH_HAVE_OTHER_UART
	depends on MCU_SERIAL
	#depends on DEV_CONSOLE - We may have serial console with no file system at all

config UART_SERIAL_CONSOLE
	bool "UART"
	depends on ARCH_HAVE_UART

config UART0_SERIAL_CONSOLE
	bool "UART0"
	depends on ARCH_HAVE_UART0

config USART0_SERIAL_CONSOLE
	bool "USART0"
	depends on USART0_ISUART

config UART1_SERIAL_CONSOLE
	bool "UART1"
	depends on ARCH_HAVE_UART1

config USART1_SERIAL_CONSOLE
	bool "USART1"
	depends on USART1_ISUART

config UART2_SERIAL_CONSOLE
	bool "UART2"
	depends on ARCH_HAVE_UART2

config USART2_SERIAL_CONSOLE
	bool "USART2"
	depends on USART2_ISUART

config UART3_SERIAL_CONSOLE
	bool "UART3"
	depends on ARCH_HAVE_UART3

config USART3_SERIAL_CONSOLE
	bool "USART3"
	depends on ARCH_HAVE_USART3

config UART4_SERIAL_CONSOLE
	bool "UART4"
	depends on ARCH_HAVE_UART4

config USART4_SERIAL_CONSOLE
	bool "USART4"
	depends on USART4_ISUART

config UART5_SERIAL_CONSOLE
	bool "UART5"
	depends on ARCH_HAVE_UART5

config USART5_SERIAL_CONSOLE
	bool "USART5"
	depends on USART5_ISUART

config UART6_SERIAL_CONSOLE
	bool "UART6"
	depends on ARCH_HAVE_UART6

config USART6_SERIAL_CONSOLE
	bool "USART6"
	depends on USART6_ISUART

config UART7_SERIAL_CONSOLE
	bool "UART7"
	depends on ARCH_HAVE_UART7

config USART7_SERIAL_CONSOLE
	bool "USART7"
	depends on USART7_ISUART

config UART8_SERIAL_CONSOLE
	bool "UART8"
	depends on ARCH_HAVE_UART8

config USART8_SERIAL_CONSOLE
	bool "USART8"
	depends on USART8_ISUART

config SCI0_SERIAL_CONSOLE
	bool "SCI0"
	depends on ARCH_HAVE_SCI0

config SCI1_SERIAL_CONSOLE
	bool "SCI1"
	depends on ARCH_HAVE_SCI1

config OTHER_SERIAL_CONSOLE
	bool "Other serial console"

config NO_SERIAL_CONSOLE
	bool "No serial console"

endchoice

#
# U[S]ARTn_XYZ settings for MCU serial drivers
#

menu "UART Configuration"
	depends on ARCH_HAVE_UART

config UART_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART_2STOP
	int "use 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART_IFLOWCONTROL
	bool "UART RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART RTS flow control

config UART_OFLOWCONTROL
	bool "UART CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART CTS flow control

endmenu

menu "UART0 Configuration"
	depends on ARCH_HAVE_UART0

config UART0_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART0_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART0_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART0_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART0_PARITY
	int "Parity setting"
	range 0 2
	default 0
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART0_2STOP
	int "use 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART0_IFLOWCONTROL
	bool "UART0 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART0 RTS flow control

config UART0_OFLOWCONTROL
	bool "UART0 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART0 CTS flow control

endmenu

menu "USART0 Configuration"
	depends on USART0_ISUART

config USART0_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config USART0_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config USART0_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the USART.

config USART0_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config USART0_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config USART0_2STOP
	int "use 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config USART0_IFLOWCONTROL
	bool "USART0 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable USART0 RTS flow control

config USART0_OFLOWCONTROL
	bool "USART0 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable USART0 CTS flow control

endmenu

menu "UART1 Configuration"
	depends on ARCH_HAVE_UART1

config UART1_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART1_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART1_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART1_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART1_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART1_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART1_IFLOWCONTROL
	bool "UART1 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART1 RTS flow control

config UART1_OFLOWCONTROL
	bool "UART1 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART1 CTS flow control

endmenu

menu "USART1 Configuration"
	depends on USART1_ISUART

config USART1_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config USART1_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config USART1_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the USART.

config USART1_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config USART1_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config USART1_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config USART1_IFLOWCONTROL
	bool "USART1 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable USART1 RTS flow control

config USART1_OFLOWCONTROL
	bool "USART1 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable USART1 CTS flow control

endmenu

menu "UART2 Configuration"
	depends on ARCH_HAVE_UART2

config UART2_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART2_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART2_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART2_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART2_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART2_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART2_IFLOWCONTROL
	bool "UART2 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART2 RTS flow control

config UART2_OFLOWCONTROL
	bool "UART2 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART2 CTS flow control

endmenu

menu "USART2 Configuration"
	depends on USART2_ISUART

config USART2_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config USART2_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config USART2_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the USART.

config USART2_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config USART2_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config USART2_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config USART2_IFLOWCONTROL
	bool "USART2 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable USART2 RTS flow control

config USART2_OFLOWCONTROL
	bool "USART2 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable USART2 CTS flow control

endmenu

menu "UART3 Configuration"
	depends on ARCH_HAVE_UART3

config UART3_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART3_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART3_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART3_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART3_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART3_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART3_IFLOWCONTROL
	bool "UART3 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART3 RTS flow control

config UART3_OFLOWCONTROL
	bool "UART3 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART3 CTS flow control

endmenu

menu "USART3 Configuration"
	depends on USART3_ISUART

config USART3_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config USART3_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config USART3_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the USART.

config USART3_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config USART3_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config USART3_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config USART3_IFLOWCONTROL
	bool "USART3 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable USART3 RTS flow control

config USART3_OFLOWCONTROL
	bool "USART3 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable USART3 CTS flow control

endmenu

menu "UART4 Configuration"
	depends on ARCH_HAVE_UART4

config UART4_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART4_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART4_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART4_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART4_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART4_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART4_IFLOWCONTROL
	bool "UART4 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART4 RTS flow control

config UART4_OFLOWCONTROL
	bool "UART4 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART4 CTS flow control

endmenu

menu "USART4 Configuration"
	depends on USART4_ISUART

config USART4_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config USART4_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config USART4_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the USART.

config USART4_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config USART4_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config USART4_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config USART4_IFLOWCONTROL
	bool "USART4 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable USART4 RTS flow control

config USART4_OFLOWCONTROL
	bool "USART4 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable USART4 CTS flow control

endmenu

menu "UART5 Configuration"
	depends on ARCH_HAVE_UART5

config UART5_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART5_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART5_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART5_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART5_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART5_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART5_IFLOWCONTROL
	bool "UART5 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART5 RTS flow control

config UART5_OFLOWCONTROL
	bool "UART5 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART5 CTS flow control

endmenu

menu "USART5 Configuration"
	depends on USART5_ISUART

config USART5_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config USART5_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config USART5_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the USART.

config USART5_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config USART5_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config USART5_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config USART5_IFLOWCONTROL
	bool "USART5 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable USART5 RTS flow control

config USART5_OFLOWCONTROL
	bool "USART5 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable USART5 CTS flow control

endmenu

menu "USART6 Configuration"
	depends on USART6_ISUART

config USART6_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config USART6_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config USART6_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the USART.

config USART6_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config USART6_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config USART6_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config USART6_IFLOWCONTROL
	bool "UART6 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable USART6 RTS flow control

config USART6_OFLOWCONTROL
	bool "USART6 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable USART6 CTS flow control

endmenu

menu "UART6 Configuration"
	depends on ARCH_HAVE_UART6

config UART6_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART6_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART6_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART6_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART6_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART6_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART6_IFLOWCONTROL
	bool "UART6 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART6 RTS flow control

config UART6_OFLOWCONTROL
	bool "UART6 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART6 CTS flow control

endmenu

menu "USART7 Configuration"
	depends on USART7_ISUART

config USART7_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config USART7_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config USART7_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the USART.

config USART7_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config USART7_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config USART7_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config USART7_IFLOWCONTROL
	bool "USART7 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable USART7 RTS flow control

config USART7_OFLOWCONTROL
	bool "USART7 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable USART7 CTS flow control

endmenu

menu "UART7 Configuration"
	depends on ARCH_HAVE_UART7

config UART7_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART7_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART7_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART7_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART7_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART7_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART7_IFLOWCONTROL
	bool "UART7 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART7 RTS flow control

config UART7_OFLOWCONTROL
	bool "UART7 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART7 CTS flow control

endmenu

menu "USART8 Configuration"
	depends on USART8_ISUART

config USART8_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config USART8_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config USART8_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the USART.

config USART8_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config USART8_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config USART8_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config USART8_IFLOWCONTROL
	bool "USART8 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable USART8 RTS flow control

config USART8_OFLOWCONTROL
	bool "USART8 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable USART8 CTS flow control

endmenu

menu "UART8 Configuration"
	depends on ARCH_HAVE_UART8

config UART8_RXBUFSIZE
	int "Receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config UART8_TXBUFSIZE
	int "Transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config UART8_BAUD
	int "BAUD rate"
	default 115200
	---help---
		The configured BAUD of the UART.

config UART8_BITS
	int "Character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config UART8_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config UART8_2STOP
	int "Uses 2 stop bits"
	default 0
	---help---
		1=Two stop bits

config UART8_IFLOWCONTROL
	bool "UART8 RTS flow control"
	default n
	select SERIAL_IFLOWCONTROL
	---help---
		Enable UART8 RTS flow control

config UART8_OFLOWCONTROL
	bool "UART8 CTS flow control"
	default n
	select SERIAL_OFLOWCONTROL
	---help---
		Enable UART8 CTS flow control

endmenu

menu "SCI0 Configuration"
	depends on ARCH_HAVE_SCI0

config SCI0_RXBUFSIZE
	int "SCI0 receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config SCI0_TXBUFSIZE
	int "SCI0 transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config SCI0_BAUD
	int "SCI0 BAUD rate"
	default 115200
	---help---
		The configured BAUD of the SCI.

config SCI0_BITS
	int "SCI0 character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config SCI0_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config SCI0_2STOP
	int "SCI0 use 2 stop bits"
	default 0
	---help---
		1=Two stop bits

endmenu # SCI0 Configuration

menu "SCI1 Configuration"
	depends on ARCH_HAVE_SCI1

config SCI1_RXBUFSIZE
	int "SCI1 receive buffer size"
	default 256
	---help---
		Characters are buffered as they are received. This specifies
		the size of the receive buffer.

config SCI1_TXBUFSIZE
	int "SCI1 transmit buffer size"
	default 256
	---help---
		Characters are buffered before being sent.  This specifies
		the size of the transmit buffer.

config SCI1_BAUD
	int "SCI1 BAUD rate"
	default 115200
	---help---
		The configured BAUD of the SCI.

config SCI1_BITS
	int "SCI1 character size"
	default 8
	---help---
		The number of bits.  Must be either 7 or 8.

config SCI1_PARITY
	int "Parity setting"
	default 0
	range 0 2
	---help---
		0=no parity, 1=odd parity, 2=even parity

config SCI1_2STOP
	int "SCI1 use 2 stop bits"
	default 0
	---help---
		1=Two stop bits

endmenu # SCI1 Configuration
